/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

public class IPAddress{
        long Address;        

    public IPAddress()
    {
	Address = 0;
    }
    
    public IPAddress(long address)
    {
	Address = address;
    }
    
    /* Remember address as 32 bit number */
    public IPAddress(String sadd)
    {
	ParseIPAddress(sadd);
    }
    
    public void setAddress(long add)
    {
        Address = add;
    }
    
    /* Convert numeric address to a dotted notation */
    public String toString()
    {
        long q, r;
	String s;
        long na=Address;
        q=na/(int)Math.pow(256,3);
        r=na-q*(int)Math.pow(256,3);
        s=new String(q+".");        
        q=r/(int)Math.pow(256,2);
        r=r-q*(int)Math.pow(256,2);
        s=s+new String(q+".");
        q=r/256;
        r=r-q*256;
        s=s+new String(q+".");
	s=s+r;
	return s;
    }
    
    public long toLong()
    {
	return Address;
    }
    
    public void PrintIPAddress()
    {
        System.out.println(this.toString());     
    }

    /* Convert dottted representation to a 32 bit number
       and set address to that number */ 
    public String ParseIPAddress(String rest)
    {
        int rec_pos;
	String address = rest;
        String add1, add2, add3, add4;
	
        rec_pos = rest.indexOf(".");
        add1 = rest.substring(0,rec_pos);       
        rest = rest.substring(rec_pos+1);
        
        rec_pos = rest.indexOf(".");
        add2 = rest.substring(0,rec_pos);
        rest = rest.substring(rec_pos+1);
 
        rec_pos = rest.indexOf(".");
        add3 = rest.substring(0,rec_pos);
        rest = rest.substring(rec_pos+1);
 
        rec_pos = rest.indexOf("/");
	if (rec_pos!=-1)
	{
        	add4 = rest.substring(0,rec_pos);   
        	rest = rest.substring(rec_pos+1);
	}
	else
		add4 = rest;

        long na=(new Integer(add1)).intValue();
        na=na*256+(new Integer(add2)).intValue();
        na=na*256+(new Integer(add3)).intValue();
        na=na*256+(new Integer(add4)).intValue();
        setAddress(na);
        return rest;
    }
};










