/*Copyright (c) 2003 The Regents of the University of California.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. All advertising materials mentioning features or use of this software
   must display the following acknowledgement:
     This product includes software developed by the University of
     California, Los Angeles and its contributors.
4. Neither the name of the University nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE. */

#ifndef __FHASH_H
#define __FHASH_H

#include "constants.h"

/* Flow record */
struct flow_stats{
  int rate_limit;
  int next_rate_limit;
  int syns_sent;
  int sentp;
  int sentB;
  int recp;
  int recB;
  int attp;
  int attB;
  int fwp;
  int fwB;
  int droppedp;
  int droppedB;
  int goodB;
  int sum_sentp;
  int sum_sentB;
  int sum_recp;
  int sum_recB;
  int sum_droppedp;
  int sum_droppedB;
  int sum_attp;
  int sum_attB;
  int sum_fwp;
  int sum_fwB;
  int goodB_old;
  unsigned int timestamp_sec;
  unsigned int timestamp_usec;
};

/* Functions declared in fhash.c */
int flow_clean(struct flow_stats*);
int flow_compare(unsigned int*, unsigned int*);
unsigned long flow_hash1(unsigned int*, unsigned long);
unsigned long flow_hash2(unsigned int*, unsigned long);
void create_flowhash();
int get_flow(unsigned int, int);
unsigned int get_timestamp_sec(unsigned int);
unsigned int get_timestamp_usec(unsigned int);
long find_flow(unsigned int);
long insert_rate_limit(unsigned int, int);
void update_flow(unsigned int, int, enum direction, int, int);
void update_flow_drop(unsigned int, int, int);
void update_flow_good(unsigned int, int);
void reset_flow(unsigned int);
void delete_rate_limit(unsigned int);
void reset_flows();
void delete_flowhash();

#endif









